# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""Xorcom USB device API"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _xusb
else:
    import _xusb

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


class Spec(object):
    r"""Represents the specification of wanted USB device"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    spec = property(_xusb.Spec_spec_get)
    ref_count = property(_xusb.Spec_ref_count_get)

    def ref(self):
        return _xusb.Spec_ref(self)

    def unref(self):
        return _xusb.Spec_unref(self)

    def __init__(self, *args):
        r"""

        vendor_id  - the vendor id number
        product_id - the product id number
        name       - arbitrary name of this class of devices

        """
        _xusb.Spec_swiginit(self, _xusb.new_Spec(*args))

    def name(self):
        r"""returns the spec name"""
        return _xusb.Spec_name(self)

    def find_all(self):
        r"""returns a tuple of all matching XusbDev objects"""
        return _xusb.Spec_find_all(self)
    __swig_destroy__ = _xusb.delete_Spec

# Register Spec in _xusb:
_xusb.Spec_swigregister(Spec)

class XusbDev(object):
    r"""Represents a single USB device"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    spec_wrapper = property(_xusb.XusbDev_spec_wrapper_get, _xusb.XusbDev_spec_wrapper_set)
    xusb_device = property(_xusb.XusbDev_xusb_device_get)
    ref_count = property(_xusb.XusbDev_ref_count_get)

    def ref(self):
        return _xusb.XusbDev_ref(self)

    def unref(self):
        return _xusb.XusbDev_unref(self)

    def __init__(self, xusb_device, spec_wrapper):
        r"""Represents a single USB device"""
        _xusb.XusbDev_swiginit(self, _xusb.new_XusbDev(xusb_device, spec_wrapper))

    def claim(self, interface_num):
        r"""opens and claims the xusb interface"""
        return _xusb.XusbDev_claim(self, interface_num)

    def interface(self, interface_num):
        r"""returns an interface object by its number"""
        return _xusb.XusbDev_interface(self, interface_num)

    def devpath(self):
        r"""returns devpath (e.g: 002/004)"""
        return _xusb.XusbDev_devpath(self)

    def manufacturer(self):
        r"""returns manufacturer string (e.g: Xorcom)"""
        return _xusb.XusbDev_manufacturer(self)

    def product(self):
        r"""returns product name string (e.g: NCS)"""
        return _xusb.XusbDev_product(self)

    def serial(self):
        r"""returns serial number string (e.g: 123456)"""
        return _xusb.XusbDev_serial(self)

    def showinfo(self):
        r"""print to stderr an identification line of this xusb object"""
        return _xusb.XusbDev_showinfo(self)

    def spec(self):
        r"""returns the spec matching to this xusb object"""
        return _xusb.XusbDev_spec(self)
    __swig_destroy__ = _xusb.delete_XusbDev

# Register XusbDev in _xusb:
_xusb.XusbDev_swigregister(XusbDev)

class XusbIface(object):
    r"""Represents a single USB interface"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    dev_wrapper = property(_xusb.XusbIface_dev_wrapper_get)
    iface = property(_xusb.XusbIface_iface_get)

    def __init__(self, iface, dev_wrapper):
        r"""Represents a single USB interface"""
        _xusb.XusbIface_swiginit(self, _xusb.new_XusbIface(iface, dev_wrapper))

    def device(self):
        r"""returns the underlying XusbDev"""
        return _xusb.XusbIface_device(self)

    def is_claimed(self):
        r"""returns if the interface is claimed"""
        return _xusb.XusbIface_is_claimed(self)

    def name(self):
        r"""returns name string (e.g: Xorcom)"""
        return _xusb.XusbIface_name(self)

    def interface_name(self):
        r"""returns interface name string (e.g: Coordinator)"""
        return _xusb.XusbIface_interface_name(self)

    def interface_num(self):
        r"""returns interface number (e.g: 1)"""
        return _xusb.XusbIface_interface_num(self)

    def __str__(self):
        r"""returns string representation of xusb (e.g: XusbIface(002/004,Coordinator,123456)"""
        return _xusb.XusbIface___str__(self)
    __swig_destroy__ = _xusb.delete_XusbIface

# Register XusbIface in _xusb:
_xusb.XusbIface_swigregister(XusbIface)


def set_verbose(v):
    r"""set verbosity level"""
    return _xusb.set_verbose(v)

def set_debug_mask(dm):
    r"""set bits of debug mask"""
    return _xusb.set_debug_mask(dm)

def find_bypath(devpath):
    r"""find matching USB device at devpath and returns its XusbDev object"""
    return _xusb.find_bypath(devpath)


